/**************************************************
 * GOURAUD SHADING POLYGONE LIBRARY BY JOSH83     *
 * Floating point fixed and assembly optimization *
 * 6/1/2001                                       *
 **************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <limits.h>


const int INFINI = INT_MIN;

int startx[200];
int endx[200];

int startcol[200];
int endcol[200];

typedef struct
    {
     int x,y,col;
    } point;

int miny,maxy;

//char far *vram = (char far*) MK_FP(vaddr, 0);

/*void HlineG(int xbeg, byte c1, int xend, byte c2, int y, word where)
{
int coloradd;

 //if (xend-xbeg) != 0 then
 coloradd = ((c2-c1) << 8) / (xend-xbeg);

 asm
  {
  mov bx,[xbeg]
  mov cx,[xend]

  inc cx
  sub cx,bx             // length of line in cx
  mov es,where          // segment to draw in
  mov ax,[y]            // Ypos of the line
  shl ax,6
  mov di,ax
  shl ax,2
  add di,ax             // y*320 in di (offset)
  add di,bx             // add x-begin

  xor ax,ax
  mov al,[c1]
  shl ax,8              // colorstart fixed-p 8.8

  again:
  mov es:[di],ah        // ah = real value of fixed-p color (ah = ax shr 8 )
  inc di
  dec cx
  add ax,[coloradd]
  cmp cx,0
  jne again
  }
}
*/

/*
void HlineG4 (int x1, char firstcolor, int x2, char lastcolor, int y)
{
int length;
int numcolors;
int colorvalue;
int step;
int x;
 if(x2<x1)
  {
    x=x1;
    x1=x2;
    x2=x;

    x=firstcolor;
    firstcolor=lastcolor;
    lastcolor=x;
  }
 length = x2 - x1 + 1;
 if (length > 0)
 {
  numcolors = lastcolor - firstcolor + 1;

  colorvalue = firstcolor << 8;
  step = ((long)numcolors << 8) / (long)length;


  for (x = x1; x <= x2; x++)
    {
     Putpixel(x,y,colorvalue >> 8,vga);
     // Draw the pixel and move to the next location in memory

     colorvalue += step;
    }
 }
}

void HlineG3 (int x1, int firstcolor, int x2, int lastcolor, int y)
{
int length;
int numcolors;
int colorvalue;
int step;
int x;
unsigned char *dest;   // Ptr to the screen

 length = x2 - x1 + 1;
 if (length > 0)
 {
  numcolors = lastcolor - firstcolor + 1;

  colorvalue = firstcolor << 8;
  step = ((long)numcolors << 8) / (long)length;

  dest = virscr + y * 320 + x1;
  // Make a pointer to the first pixel

  for (x = x1; x <= x2; x++)
    {
     *dest++ = colorvalue >> 8;
     // Draw the pixel and move to the next location in memory

     colorvalue += step;
    }
 }
}

void HlineG2(int x1, int coul1, int x2, int coul2, int y)
{
  long difx,pas;
  long nbcoul,couleur;
  long x;
  long indice;

  if(x2<x1)
  {
    x=x1;
    x1=x2;
    x2=x;

    x=coul1;
    coul1=coul2;
    coul2=x;
  }

  difx=x2-x1+1;

  nbcoul  = coul2-coul1+1;
  couleur = coul1<<8;
  pas     = (nbcoul<<8)/difx;

  for(x=x1;x<=x2;x++)
  {
    if(x>=0 && x<320)
      Putpixel(x,y,couleur>>8,vga);
    couleur+=pas;
  }
}
*/

void HlineG (int x1, int firstcolor, int x2, int lastcolor, int y,word where)
{
unsigned char far *dest = (char far*) MK_FP(where, 0);
int length;
int numcolors;
int colorvalue;
int step;
int x;
//unsigned char far *dest;   // Ptr to the screen

length = x2 - x1 + 1;
numcolors = lastcolor - firstcolor + 1;
colorvalue = firstcolor << 8;
step = ((long)numcolors << 8) / (long)length;

dest += y * 320 + x1;  // Make a pointer to the first pixel

  asm {
	mov cx, word ptr length		// Set length
	les di, dest			// Set destination ptr
	mov ax, word ptr colorvalue	// Set color
       }
    shadedlineloop:
    ;
    asm {
	mov es:[di], ah			// Move color to screen
	add ax, word ptr step  		// Add to color
	inc di				// Move to next pixel
	dec cx				// Decrease length
	jnz shadedlineloop		// Repeat for all pixels
	}
}

void PolyLine (int x1, int y1, int col1, int x2, int y2, int col2)
/* Calculates the coordinates of a line given two
   vertices (x1,y1) with color col1,  and (x2,y2) with color col2.

   We will use fixed point math to speed things up.
   The x coordinate is multiplied by 256 and for each row,
   a constant m is added to x.  This is a simplified version
   of a line algorithm because we only have to store 1 x coordinate
   for every y coordinate.

   The color value is increase by a step value based on the
   number of colors between the vertices and the distance between the
   y coordinates*/

{
 int tmp,y;
 long x,m;
 long col, colstep;   // First color, and the step value

 if (y2 != y1)      // This isn't a horizontal line
 {
   if (y2 < y1)    // Make sure y2 is greater than y1
   {
    tmp = y1;      // Swap the y coordinate
    y1 = y2;
    y2 = tmp;

    tmp = x1;      // Swap the corresponding x coordinates
    x1 = x2;
    x2 = tmp;

    tmp = col1;    // Swap the corresponding color values
    col1 = col2;
    col2 = tmp;
   }

 x = (long)x1<<8;  // Multiply be 256

 m = ((long)(x2 - x1)<<8) / ((long)(y2 - y1));
 /* m is the fractional amount to add to the x coordinate every row.
    m is equal to (delta x) / (delta y).  In other words, the x coordinate
    has to change by (x2 - x1) columns in (y2 - y1) rows. */

 col = (long)col1 << 8;	 /* Initial color in 8.8 fixed point format */
 colstep = ((long)(col2 - col1) << 8) / ((long)(y2 - y1));
 /* Calculate the color step value similar to the method in the
    shadedline routine, only we're dividing by the delta y value. */


 x += m; // We ALWAYS skip the first point in every line. This is done */
 y1++; /* because we do not want to store the point where two lines
	  meet, twice.  This would result in a single point being drawn. */
 col +=colstep;

 for (y = y1; y <= y2; y++) // Go through each row
  {
   if ((y >= 0) & (y < 200)) // If the coordinate is on the screen
    if (startx[y] == -16000) // Store the first coordinate
      {
       startx[y] = x>>8;
       startcol[y] = col >> 8;	// store the color
      }
    else
      {
       endx[y] = x>>8;        // Store the last coordinate
       endcol[y] = col >> 8;
      }
   x += m;		     // Add our constant to x
   col += colstep;
   }
 }
}


void FillPoly (point *vertexlist, int numvertex)
{
int i;
point *curpt,*nextpt;
  /* Two pointers to a vertex. These are used to connect to vertices
     together in when calling the gpolyline routine. */

 curpt = vertexlist;      // Set to the first vertex in the array
 nextpt = vertexlist + 1; // and to the second vertex

 for (i = 0; i < 200; i++)
  {
   startx[i] = -16000;     // Set up our impossible values
   endx[i] = -16000;
  }

 for (i = 1; i < numvertex; i++)
  {
   PolyLine (curpt->x,  curpt->y,  curpt->col,nextpt->x, nextpt->y, nextpt->col);

   curpt += 1;  // Go to the next line
   nextpt += 1;
  }

  nextpt = vertexlist;  /* Now close the polygon by doing a line between
			   the first and last vertex. */
  PolyLine (curpt->x,  curpt->y,  curpt->col,nextpt->x, nextpt->y, nextpt->col);

  for (i = 0; i < 200; i++)   // Now draw the horizontal line list
    if (startx[i] != -16000)  // Indicates there is a line on this row
    {
     if (endx[i] == -16000)
	 endx[i] = startx[i]; // In case there was only one
       if(startx[i]<endx[i])
       HlineG(startx[i],startcol[i],endx[i],endcol[i],i,vaddr);
       else
       HlineG(endx[i],endcol[i],startx[i],startcol[i],i,vaddr);
       /* Draw a shaded line between the two x coordinates, on the row i.*/
    }
}
