//TEXTURE MAPPING ROUTINE CODED BY JOSH83

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <limits.h>

int startx[200];
int endx[200];

typedef struct
    {
    int us,vs;
    int ue,ve;
    } texm;

typedef struct
    {
     int x,y,u,v;
    } point;

int miny,maxy;
texm texmap[200];

//---


void HlineT3(int x1,int u1,int v1,int x2,int u2,int v2,int y,word where)
{
unsigned char far *dest = (char far*) MK_FP(where, 0);
  long longueur;
  long deltax,deltay;
  long xincr,yincr;
  long xpos,ypos;
  int  indice;
  long src;
  int  x,temp;


  if(x1>x2)
  {
    temp=x1; x1=x2; x2=temp;
    temp=u1; u1=u2; u2=temp;
    temp=v1; v1=v2; v2=temp;
  }

  longueur=x2-x1+1;
  if(longueur>0)
  {
    deltax = u2-u1+1;
    deltay = v2-v1+1;

    indice = y*320+x1;

    src    = v1*128+u1;    // 320 = largeur texture

    xincr=((long)(deltax)<<8)/(long)longueur;
    yincr=((long)(deltay)<<8)/(long)longueur;

    xpos=u1<<8;
    ypos=v1<<8;

    for(x=x1;x<=x2;x++)
    {
      src = (xpos>>8) + (ypos>>8)*128;
      dest[indice++]=image[src];
      xpos+=xincr;
      ypos+=yincr;
    }
  }
}

//---

/*void HlineT (int x1, int u1, int v1, int x2, int u2, int v2, int y)
{

long length;
long deltax, deltay;

unsigned char far * dest;
unsigned char far * src;

int xincr,yincr;
int xpos, ypos;
int t;

if (x1 > x2)
  {
  t = x1; x1 = x2; x2 = t;
  t = u1; u1 = u2; u2 = t;
  t = v1; v1 = v2; v2 = t;
  }

length = x2 - x1 + 1;

if (length > 0)
  {
  deltax = u2 - u1 + 1;
  deltay = v2 - v1 + 1;

  dest = abuf + y * 320 + x1;
  src  = textureimage + v1 * 256 + u1;

  xincr = ((long)(deltax) << 8) / (long)length;
  yincr = ((long)(deltay) << 8) / (long)length;

 xpos = u1<<8;
 ypos = v1<<8;

 asm {
       .386
       push ds
       cld
       mov cx, word ptr length		// Set length
       shr cx, 1
       les di, dest			// Set destination ptr
       lds si, src			// Set source ptr
       mov dx, word ptr ypos		// Put the y in the low word
       shl edx, 16                      // Move the y to the high word
       mov dx, word ptr xpos		// Put the x in the low word

       mov si, word ptr yincr		// Set up the increments the
       shl esi, 16			// same way
       mov si, word ptr xincr
      // Now to advance one pixel, we can add edx and esi together to
      // advance the x and y at the same time, with the fractional
      // portion automatically carrying at 256.

      cmp cx, 0
      je onepixel
      }
  tlineloop:
  ;
  asm {
       mov ebx, edx
       shr ebx, 16      // BH now contains the y coordinate
       mov bl, dh	// Store the x value in BL
			// BX is now an offset into the texture image,
			// between 0 and 65535.
       mov al, ds:[bx]	// Get the color from the texture image
       add edx, esi	// Advance one pixel

       mov ebx, edx	// Repeat the above, and get another pixel
       shr ebx, 16
       mov bl, dh
       mov ah, ds:[bx]
       add edx, esi

       stosw		// Store a word to the destination
       dec cx		// Decrease length
       jnz tlineloop	// Repeat for all pixels
      }
  onepixel:
   asm {
       mov cx, word ptr length
       and cx, 1
       jz tlinedone

       mov ebx, edx
       shr ebx, 16      // BH now contains the y coordinate
       mov bl, dh	// Store the x value in BL,
			// BX is now an offset into the texture image,
			//   between 0 and 65535.
       mov al, ds:[bx]	// Get the color from the texture image
       mov es:[di], al

    }
   tlinedone:
   asm {
       pop ds
      }

  }
}

//---
*/
void HlineT (int x1,int u1,int v1,int x2,int u2,int v2,int y,word where)
{
unsigned char far *dest = (char far*) MK_FP(where, 0);
long difx,difu,difv;
int temp,x;
long u,v;
long ustep,vstep;
long indice,src;

if(x1>x2)
  {
    temp=x1; x1=x2; x2=temp;
    temp=u1; u1=u2; u2=temp;
    temp=v1; v1=v2; v2=temp;
  }

difx = x2 - x1 +1;

if(difx>0)
{

indice = y*320+x1;
src = u1*128+v1;

difu = u2 - u1 + 1;
difv = v2 - v1 + 1;

u = u1<<8;
ustep = (difu<<8) / difx;
v = v1<<8;
vstep = (difv<<8) / difx;

for (x = x1; x <= x2; x++)
    {
     src = (v>>8) + (u>>8)*128;
     dest[indice++]=image[src];
     u += ustep;
     v += vstep;
    }
}
}

//-------------------------------------------------------------------------


void PolyLine (int x1, int y1, int u1, int v1, int x2, int y2, int u2,int v2)
{
 int tmp,y;
 long x, xstep;
 long u, ustep;
 long v, vstep;

 if (y2 != y1)
 {
   if (y2 < y1)
   {
    tmp = y1; y1 = y2; y2 = tmp;
    tmp = x1; x1 = x2; x2 = tmp;
    tmp = u1; u1 = u2; u2 = tmp;
    tmp = v1; v1 = v2; v2 = tmp;
   }

 x = (long)x1 << 8;
 xstep = ((long)(x2 - x1) << 8) / ((long)(y2 - y1));
 u = (long)u1 << 8;
 ustep = ((long)(u2 - u1) << 8) / ((long)(y2 - y1));
 v = (long)v1 << 8;
 vstep = ((long)(v2 - v1) << 8) / ((long)(y2 - y1));

 x += xstep;
 u += ustep;
 v += vstep;

 y1++;

 for (y = y1; y <= y2; y++)
 {
   if ((y >= 0) & (y < 200))
    if (startx[y] == -16000)
      {
       startx[y] = x>>8;
       texmap[y].us = u >> 8;
       texmap[y].vs = v >> 8;
      }
    else
      {
       endx[y] = x>>8;
       texmap[y].ue = u >> 8;
       texmap[y].ve = v >> 8;
      }
   x += xstep;
   u += ustep;
   v += vstep;
   }
 }
}

//---

void FillPoly (point *vertexlist, int numvertex)
{
int i;
point *curpt,*nextpt;

curpt = vertexlist;
nextpt = vertexlist + 1;

for (i = 0; i < 200; i++)
  {
  startx[i] = -16000;
  endx[i] = -16000;
  }

for (i = 1; i < numvertex; i++)
  {
  PolyLine (curpt->x, curpt->y, curpt->u, curpt->v, nextpt->x, nextpt->y, nextpt->u, nextpt->v);
  curpt += 1;
  nextpt += 1;
  }

nextpt = vertexlist;
PolyLine (curpt->x, curpt->y, curpt->u, curpt->v, nextpt->x, nextpt->y, nextpt->u, nextpt->v);

for (i = 0; i < 200; i++)
  {
  if (startx[i] != -16000)
    {
    if (endx[i] == -16000)
      endx[i] = startx[i];
    HlineT(startx[i],texmap[i].us,texmap[i].vs,endx[i],texmap[i].ue,texmap[i].ve,i,vaddr);
    }
  }
}
