#include <graphics.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>

/* the names of the line styles supported */
char *lnome[] = {"SOLID_LINE","DOTTED_LINE","CENTER_LINE","DASHED_LINE",
   "USERBIT_LINE"};

int main(void)
{
   /* request auto detection */
   int gdriver = DETECT, gmode, errorcode;

   int estilo, midx, midy, padrao;
   char estilostr[40];

   /* initialize graphics and local variables */
   initgraph(&gdriver, &gmode, "");

   /* read result of initialization */
   errorcode = graphresult();
   if (errorcode != grOk)  /* an error occurred */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1); /* terminate with an error code */
   }

   midx = getmaxx() / 2;
   midy = getmaxy() / 2;

   /* a user defined line pattern */
   /* binary: "0000000000000001"  */
   padrao = 1;

   for (estilo=SOLID_LINE; estilo<=USERBIT_LINE; estilo++)
   {
      /* select the line style */
      setlinestyle(estilo, padrao, 1);

      /* convert style into a string */
      strcpy(estilostr, lnome[estilo]);

      /* draw a line */
      line(0, 0, midx-10, midy);

      /* draw a rectangle */
      rectangle(0, 0, getmaxx(), getmaxy());

      /* output a message */
      outtextxy(midx, midy, estilostr);

      /* wait for a key */
      getch();
      cleardevice();
   }

   /* clean up */
   closegraph();
   return 0;
}