/* Atrelar ao programa relogio.c */

#ifndef GR_LIB
#define GR_LIB
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>
#include <math.h>
#include <graphics.h>
#define PI            M_PI
#define DELAY_TIME    500
#define OFFSET        1
#define ROUND(x) (((x)>0) ? long((x)+.5) : long((x)-.5))
#define SQR(x)   ((x)*(x))
#define MIN(x,y) (((x)<(y))?(x):(y))
#define MAX(x,y) (((x)>(y))?(x):(y))

int feol(FILE*);
void inigraf(int=BLACK, int=0);
char* inteiro(int);
void lel(FILE*, char*);
void lel(FILE*);
double log(int, double);
int login(int, int);
double normaliza(double, int&);
void pausa(int=LIGHTCYAN);
char* pega_string();
int potin(int, int);
char* real(double, int, int);
int repete(int=LIGHTCYAN);

int feol(FILE *f)
{
   unsigned char c;
   
   fscanf(f, "%c", &c);
   if (feof(f) || (c == '\n') || (c == '\r')) return(1);
   ungetc(c, f);
   return(0);
}

void inigraf(int background_color, int prn_scrn)
{
int driver, modo, erro;
   driver = DETECT;
   initgraph(&driver, &modo, "c:\\tc\\BGI");
   erro = graphresult();
   if (erro != grOk)
   {
       printf("Erro: %s\n", grapherrormsg(erro));
       exit(erro);
   }
   if (driver == VGA)
      setgraphmode(VGAMED);
   setbkcolor(background_color);
   if (prn_scrn)
   {
      setpalette(BLACK, 63);
      setpalette(WHITE, 0);
   }
}

char* inteiro(int n)
{
   char* s = pega_string();
   int decs;
   int i = 0;
   if (n < 0) s[i++] = '-';
   n = abs(n);
   decs = potin(10, login(10, n));
   for (; decs>0; ++i)
   {
      s[i] = n / decs + '0';
      n %= decs;
      decs /= 10;
   }
   s[i] = NULL;
   return(s);
}

void lel(FILE* f, char *s)
{
   char ch;
   int i = 0;
   
   if (!feof(f) ) ch = fgetc(f);
   while (!feof(f) && (ch != '\n') && (ch != '\r'))
   {
       s[i++] = ch;
       ch = fgetc(f);
   }
   s[i] = NULL;
}

void lel(FILE* f)
{
   char ch;
   
   if (!feof(f)) ch = fgetc(f);
   while (!feof(f) && (ch != '\n') && (ch != '\r')) ch = fgetc(f);
}

double log(int b, double x)
{
   if (x > 0) return(log(x) / log(b));
   else if (x < 0) return(-(log(-x) / log(b)));
   else return(0);
}

int login(int b, int n)
{
   return((n>=b) ? (1+login(b,n/b)) : (0));
}

double normaliza(double x, int &n) /* Uso na funcao real */
{
   if (abs(x) >= 10) return(normaliza(x/10, ++n));
   else if (x == 0) return(0);
   else if (abs(x) < 1) return(normaliza(x*10, --n));
   else return(x);
}

void pausa(int cor)
{
   char* prompt = "Pressione qualquer tecla para continuar!";
   int cor_ant = getcolor();

   fflush(stdin);
   setcolor(cor);
   settextjustify(LEFT_TEXT, BOTTOM_TEXT);
   settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
   outtextxy(OFFSET, getmaxy()-OFFSET, prompt);
   getch();
   bar(0, getmaxy()-textheight(prompt)-OFFSET, textwidth(prompt)+OFFSET, getmaxy());
   setcolor(cor_ant);
}

char* pega_string()
{
   static char s[256];
   return(s);
}

int potin(int x, int n)
{
   return((n>0) ? (x*potin(x,n-1)) : (1));
}

char* real(double x, int comp, int dec=-1)
{
   char* s = pega_string();
   
   if (dec >= 0)
   {
      int comp_int, n;
      double valor_frac;
      int decs;
      int sinal = 0;
      
      if (x < 0)
      {
         x = -x;
         ++sinal;
      }
      n = x;
      valor_frac = x - n;
      comp_int = login(10, n) + 1;
      if (comp-dec-1-sinal < comp_int) comp = comp_int + dec + 1 + sinal;
      decs = potin(10, comp_int-1);
      for (int j=0; j<comp-dec-1-comp_int-sinal; ++j) s[j] = ' ';
      if (sinal) s[j++] = '-';
      for (int i=j; i<comp-dec-1; ++i)
      {
         s[i] = n/decs + '0';
         n %= decs;
         decs /= 10;
      }
      s[i++] = '.';
      for (j=0; j<dec; ++j)
      {
         s[i+j] = int(valor_frac * 10) + '0';
         valor_frac *= 10;
         valor_frac -= int(valor_frac);
      }
      s[i+j] = NULL;
   }
   else
   {
      int exp = 0;
      int sinal = 0;
      
      x = normaliza(x, exp);
      if (x < 0)
      {
         x = -x;
         ++sinal;
         s[0] = '-';
      }
      if (comp-sinal < 7)
         comp = 7 + sinal;
         s[sinal] = int(x) + '0';
      x -= int(x);
      s[sinal+1] = '.';
      for (int i=0; i<comp-6; ++i)
      {
         x *= 10;
         s[sinal+2+i] = int(x) + '0';
         x -= int(x);
      }
      s[sinal+2+i++] = 'E';
      if (exp < 0) s[sinal+2+i++] = '-';
      else s[sinal+2+i++] = '+';
      s[sinal+2+i++] = exp/10%10 + '0';
      s[sinal+2+i++] = exp%10 + '0';
      s[sinal+2+i] = NULL;
   }
   return(s);
}

int repete(int color)
{
   char prompt[80] = "Quer repetir (S/N)? ";
   char resp[2] = "";
   int cor_ant;

   cor_ant = getcolor();
   setcolor(color);
   settextjustify(LEFT_TEXT, BOTTOM_TEXT);
   settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
   outtextxy(OFFSET, getmaxy()-OFFSET, prompt);
   do
   {
      fflush(stdin);
      resp[0] = getch();
      resp[0] = toupper(resp[0]);
   }
   while ((resp[0] != 'S') && (resp[0] != 'N'));
   outtextxy(textwidth(prompt)+OFFSET, getmaxy()-OFFSET, resp);
   delay(DELAY_TIME);
   setfillstyle(EMPTY_FILL, 0);
   strcat(prompt, "S");
   bar(0, getmaxy()-textheight(prompt)-OFFSET, textwidth(prompt)+OFFSET, getmaxy());
   setcolor(cor_ant);
   return(resp[0] == 'S');
}

#endif GR_LIB