/* ***********************************************
      relogio.cpp   (Turbo C++ 3.0)
	Simulacao grafica de um relogio analogico     
   *********************************************** */

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <dos.h>
#include <math.h>
#include <graphics.h>
#include <time.h>

/* Inclusao de arquivos de referencia */
#include "c:\arquiv~1\turboc~1\progra~1\source\grafutil.cpp"  /* Utilitarios graficos */
#include "c:\arquiv~1\turboc~1\progra~1\source\grafinit.cpp"  /* Inicializadores graficos */

/* Prototipos de funcoes */ 
long double arredld(long double); /* Funcao para arredondamento de variaveis do tipo 'long double' */

double figX(double,double,double,int,int); /* Manipulacao grafica no eixo X */

double figY(double,double,double,int,int, double); /* Manipulacao grafica no eixo Y */

main()
{
	inigraf();
	
	/* Declaracoes de variaveis */
	int h,m,s;
	struct time t,t2;
	int xc,yc;
	int inx,iny;
	double linx,liny;
	int xdist,ydist,fx,fy,comptr;
	int distnum,numx,numy,i;
	double pontc,pontv;
	double rads;
	char strnum[3];
	int aspx,aspy;
	double relxy;
	int cont;

	/* Array numerico na sequencia de desenho na tela */
	int cnumero[] = {3,9,9,3,2,10,8,4,1,11,7,5,12,12,6,6};

	int p=0; /* Configuracao da pagina para zero */

      /* Prosseguimento do desenho do relogio em outra pagina */
	while (!kbhit())
	{
		setvisualpage(p);
		setactivepage(1-p);

		setcolor(0);
		rectangle(0,0,639,379);
		//cleardevice(); /* Apagamento da tela */

		/* Inicializacao de variaveis */
		int cont = 0;
		int cnum = 0;
		int r = getmaxx()/4;
		linx = liny = 0;
		xdist = ydist = fy = fx = comptr = 0;
		distnum = numx = numy = i =0;
		rads = inx = iny = 0;
		pontv = pontc = 0;
		aspx = aspy = 0;
		relxy = 0;

		/* Aquisicao da relacao de aspo da tela grafica */
		getaspectratio(&aspx, &aspy);
		relxy = double (aspx)/(aspy);

		setlinestyle(SOLID_LINE,SOLID_FILL,THICK_WIDTH); /* Configuracao do estilo da linha */
		setcolor(6); /* Configuracao da cor da linha (BRANCO) */
		setfillstyle(SOLID_FILL,0);
		fillellipse(xc,yc,r,relxy*r); /* Tracado do circulo */
		setcolor(14);

		/* Aquisicao das componentes HORA, MINUTO e SEGUNDO do horario*/
		gettime(&t);
		h = t.ti_hour;
		m = t.ti_min;
		s = t.ti_sec;

		/* Conversao do horario Universal para o horario Padrao*/
		if (h>12) h -=12;

		/* Desenho das marcacoes e numeros do relogio */
		for (; cont<=90; cont+=6) /* Tracado de segmentos de reta menores a cada 6 graus */
		{
			rads = (cont/180.00)*3.141593; /* Conversao de graus para radianos */
			linx = cos(rads)*r + xc; /* Representacao de x em um circulo */
			liny = (yc - (sin(rads)*r)*relxy); /* Representacao de y em um circulo */

			inx = ( (int)arredld(linx) ); /* Arredondamento de linx */
			iny = ( (int)arredld(liny) ); /* Arredondamento de liny */

			/* Teste para a representacao de marcacoes maiores com numeros ou menores sem numeros */
			if (cont ==0 || cont ==30 || cont==60 || cont==90) /* SE quartos de hora */
			{
				setlinestyle(SOLID_LINE,SOLID_FILL,THICK_WIDTH);
				comptr = 100/10; /* Definicao do comprimento dos tracos maiores */
				distnum = 100/20; /* Definicao da distancia dos numeros */
				numx = inx - (inx-xc)/distnum;
				numy = iny + (yc-iny)/distnum;

				settextjustify(CENTER_TEXT,CENTER_TEXT);
				settextstyle(DEFAULT_FONT,HORIZ_DIR,2);//magnif. factor=2

				cnum = cnumero[i];
				itoa(cnum,strnum,10); /* Conversao de inteiro para string */
				outtextxy(numx,numy,strnum); /* Desenho do numero do primeiro quarto de hora */

				numx = xc - (numx-xc); /* Novo numero em x */
				cnum = cnumero[++i];
				itoa(cnum,strnum,10);
				outtextxy(numx,numy,strnum); /* Desenho do numero do segundo quarto de hora */

				numy = yc +(yc-numy); /* Novo numero em y */
				cnum = cnumero[++i];
				itoa(cnum,strnum,10);
				outtextxy(numx,numy,strnum); /* Desenho do numero do terceiro quarto de hora */

				numx = xc + (xc-numx); /* Novo (antigo)numero em x */
				cnum = cnumero[++i];
				itoa(cnum,strnum,10);
				outtextxy(numx,numy,strnum); /* Desenho do numero do quarto quarto de hora */

				i+=1; /* Incremento do array para o primeiro quarto de hora */
			}
			else /* SE demais marcacoes */
			{
				setlinestyle(SOLID_LINE,SOLID_FILL,NORM_WIDTH);
				comptr = 100/5; /* Comprimento dos tracos maiores */
			} /* Termino do teste */

			xc = getmaxx()/2;
			yc = getmaxy()/2;

			/* Tracado das marcacoes */

			fx=inx-(inx-xc)/comptr;
			fy=iny+(yc-iny)/comptr;

			//setcolor(6);
			line(inx,iny,fx,fy); /* Tracado no primeiro quadrante */
			xdist=inx-xc; /* Aquisicao da distancia do centro ao ponto inicial no eixo X */
			inx=xc-xdist; /* Novo ponto inicial no eixo X */
			fx=xc-(fx-xc); /* Novo ponto final no eixo X */

			line(inx,iny,fx,fy); /* Tracado no segundo quadrante */
			ydist=yc-iny; /* Aquisicao da distancia do centro ao ponto inicial no eixo Y */
			iny=yc+ydist; /* Novo ponto inicial no eixo Y */
			fy=yc+(yc-fy); /* Novo ponto final no eixo Y */

			line(inx,iny,fx,fy); /* Tracado no terceiro quadrante */
			inx=xc+xdist;  /* Novo ponto inicial (antigo) no eixo X */
			fx=xc+(xc-fx); /* Novo ponto final (antigo) no eixo X */

			line(inx,iny,fx,fy); /* Tracado no quarto quadrante */
		} /* Termino do tracado das marcacoes e desenho dos numeros do relogio */

	/* Tracado dos ponteiros do relogio */

	/* Ponteiro dos segundos */
	pontc = 100/80.00;
	pontv = (s*6)-90;
	rads =(pontv/180.00)*3.141593;
	fx = ((int) figX(rads,pontv,pontc,xc,r));
	fy = ((int) figY(rads,pontv,pontc,yc,r,relxy) );
	setlinestyle(SOLID_LINE,SOLID_FILL,NORM_WIDTH);
	setcolor(11);
	line (xc,yc,fx,fy);

	/* Ponteiro dos minutos */
	pontc = 100/70.00;
	pontv = (m*6)-90;
	rads=(pontv/180.00)*3.141593;
	fx = ((int) figX(rads,pontv,pontc,xc,r));
	fy = ((int) figY(rads,pontv,pontc,yc,r,relxy) );
	setlinestyle(SOLID_LINE,SOLID_FILL,THICK_WIDTH);
	setcolor(9);
	line (xc,yc,fx,fy);

	/* Ponteiro das horas */
	pontc = 100/50.00;
	pontv = (h*30)+(m*.5)-90;
	rads = (pontv/180.00)*3.141593;
	fx = ((int) figX(rads,pontv,pontc,xc,r));
	fy = ((int) figY(rads,pontv,pontc,yc,r,relxy));
	setcolor(1);
	line (xc,yc,fx,fy);


	if (p == 1) p = 0; /* Mudanca de pagina */
	else p = 1;

	} /* Termino do WHILE com KBHIT */

	closegraph(); /* Encerramento do modo grafico */
	return 0;
}

long double arredld(long double num)
{ /* Arredondamento de numeros do tipo 'long double' */
	long double testanum = 0;
	int testanumi = 0, nint= 0;

	testanum = ((num*10));
	testanumi = testanum;

	if ((testanumi%10) >= 5) nint = ceil(num); /* Arredondamento para mais */
	else nint = floor(num); /* Arredondamento para menos */

	return nint;
}

double figX(double rad, double valor, double comp, int centro, int r)
{
	double fim =0;
	int ifim=0;
	fim = ((r*cos(rad))/comp) + centro;
	ifim=((int)arredld(fim)); /* Chamada da funcao para arredondamento de numeros do tipo 'long double' */

	return ifim;
}

double figY(double rad, double valor, double comp, int centro, int r, double asp)
{
	double fim = 0;
	int ifim = 0;
      
	/* Uso da relacao de aspecto */
	if(valor >= -90 || valor <=90) fim = (((r*sin(rad)))/comp)*asp + centro; /* Valor no primeiro ou
	segundo quadrante (y positivo) */
	else fim = (((-1)*(r*sin(rad)))/comp)*asp + centro;

	ifim = ((int)arredld(fim)); /* Chamada da funcao para arredondamento de numeros do tipo 'long double' */
	
	return ifim;

}